config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { sessions: 'users/sessions' }

  namespace :admin do
    get '/', to: 'reports#index'
    resources :users
    resources :properties
    resources :reports
    resources :bids, only: [:index, :edit, :update, :destroy]
  end

  root 'home#index'
  get 'about' => 'home#about'
  get 'contact' => 'home#contact'
  get 'price' => 'home#price'
  get 'order' => 'home#order'
  post 'orders' => 'home#create_order'

end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  serialize :roles, Array

  def is?(role)
    self.roles.include?(role.to_s)
  end
end

app/controllers/admin/users_controller.rb
class Admin::UsersController < Admin::AdminController
  before_action :set_user, only: [:show, :edit, :update, :destroy]
  ROLES = ['superadmin', 'admin', 'operational']

  def index
    @users = User.all
  end

  def edit
  end

  def new
    @user = User.new
  end

  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to admin_users_path, notice: 'User Data berhasil diubah' }
      else
        format.html { render :edit }
      end
    end
  end

  def create
    @user = User.new(user_params)
    respond_to do |format|
      if @user.save
        format.html { redirect_to admin_users_path, notice: 'User Data berhasil dibuat' }
      else
        format.html { render :new }
      end
    end
  end

  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to admin_users_path, notice: 'User Data berhasil dihapus' }
    end
  end

  private
    def set_user
      @user = User.find(params[:id])
    end
    def user_params
      params.require(:user).permit(:email, :password, :first_name, :last_name,
                                   :password_confirmation, :roles => [])
    end

end

app/controllers/users/confirmations_controller.rb
class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/omniauth_callbacks_controller.rb
class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/plataformatec/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/users/passwords_controller.rb
class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
class Users::RegistrationsController < Devise::RegistrationsController
# before_action :configure_sign_up_params, only: [:create]
# before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_up_params
  #   devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute])
  # end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users/sessions_controller.rb
class Users::SessionsController < Devise::SessionsController
# before_action :configure_sign_in_params, only: [:create]
  layout "user"

  # GET /resource/sign_in
  def new
    super
  end

  # POST /resource/sign_in
  def create
    super
  end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/views/admin/users/_form.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="page-title">
            <span class="title">User Data</span>
        </div>
        <div class="row">
            <div class="col-xs-12">
                <div class="card">
                    <div class="card-body">
                      <%= form_for [:admin, @user] do |form| %>
                      <% if @user.errors.any? %>
                        <div class="alert fresh-color alert-danger" role="alert">
                          <ul>
                            <% @user.errors.full_messages.each do |message| %>
                            <li>
                              <strong><%= message %></strong>
                            </li>
                            <% end %>
                          </ul>
                        </div>
                        <% end %>
                        <div class="sub-title">Role User</div>
                        <div>
                          <%= form.check_box :roles, { :multiple => true }, 'superadmin', nil %>
                          <%= form.label :roles, "superadmin" %>
                          <%= form.check_box :roles, { :multiple => true }, 'admin', nil %>
                          <%= form.label :roles, "admin" %>
                          <%= form.check_box :roles, { :multiple => true }, 'operational', nil %>
                          <%= form.label :roles, "operational" %>
                        </div>
                        <div for="name" class="sub-title">First Nama</div>
                        <div>
                            <%= form.text_field :first_name, class: 'form-control', placeholder: 'first_name' %>
                        </div>
                        <div class="sub-title">Last_name</div>
                        <div>
                            <%= form.text_field :last_name, class: 'form-control', placeholder: 'last_name'  %>
                        </div>
                        <div class="sub-title">Email</div>
                        <div>
                            <%= form.text_field :email, class: 'form-control', placeholder: 'last_name'  %>
                        </div>
                        <div class="sub-title">Password</div>
                        <div>
                            <%= form.password_field :password, class: 'form-control', placeholder: 'password'  %>
                        </div>
                        <div class="sub-title">Password Confirmation</div>
                        <div>
                            <%= form.password_field :password_confirmation, class: 'form-control', placeholder: 'password_confirmation'  %>
                        </div>
                        <%= link_to 'Back', admin_users_path, class: "btn btn-sm btn-default" %>
                        <button type="submit" class="btn btn-sm btn-info">Submit</button>
                      <% end %>
                    </div>
                </div>
            </div>
        </div>
    </div>

app/views/admin/users/edit.html.erb
<%= render 'form' %>

app/views/admin/users/index.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="row">
            <div class="col-xs-12">
                <div class="card">
                    <div class="card-header">
                        <div class="card-title">
                        <div class="title">User Data</div>
                        </div>
                        <div class="pull-right card-action">
                          <%= button_to "Buat User Data", new_admin_user_path, class: 'btn btn-info', method: 'get' %>
                        </div>
                    </div>
                    <div class="card-body">
                      <% if notice %>
                        <div class="alert alert-success" role="alert">
                          <strong><%= notice %></strong></a>
                        </div>
                      <% end %>
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th bgcolor="#9adbf9" width="5%">No</th>
                                    <th bgcolor="#9adbf9">Email</th>
                                    <th bgcolor="#9adbf9">Name</th>
                                    <th bgcolor="#9adbf9">Role</th>
                                    <th width="10%" bgcolor="#9adbf9" colspan="2"></th>
                                </tr>
                            </thead>
                            <tbody>
                                <% @users.each_with_index do |user, index|%>
                                  <tr>
                                      <th scope="row"><%= index + 1 %></th>
                                      <td><%= user.email %></td>
                                      <td><%= user.first_name %> <%= user.last_name %></td>
                                      <td><%= user.roles %></td>
                                      <td><%= link_to 'Edit', edit_admin_user_path(user), class: "btn btn-sm btn-warning" %></td>
                                      <td><%= link_to 'Hapus', [:admin, user], method: :delete, data: { confirm: 'Apakah anda yakin ?' }, class: "btn btn-sm btn-danger" %></td>
                                  </tr>
                                <% end %>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

app/views/admin/users/new.html.erb
<%= render 'form' %>